/*
 * remove-spaces.c
 * 
 * This program cleans string from an extra spaces
 *
 * e.g. string
 *   "____Hello__World!_"
 * Be replaced with string
 *   "Hello_World!"
 *
 */

#include <stdio.h>
#include <string.h>

#define N 256
#define STATE_1 1
#define STATE_2 2

int remove_n(char *arr, int len) {
  int len2 = len-1;
  
  if('\n' == arr[len2])
    arr[len2] = 0;

  return 0;
}

int remove_spc(char *arr, int len, int pos) {
  int i;
  int len2 = len-1;
  
  for(i = pos; i <= len2; i++) {
    arr[i] = arr[i+1];
  }

  return 0;
}

int main() {
  char charray[N];
  int len;
  int i=0;
  int state=STATE_1;

  printf("Please enter string:\n>");
  fgets(charray, N, stdin);

  len = strlen(charray);
  remove_n(charray, len);

  while(1) {
    
    switch(state) {
      
    case STATE_1:
      if(' ' == charray[i]) {
        state = STATE_2;
        if(0 == i)
          continue;
      }
      break;
      
    case STATE_2:
      if(' ' != charray[i]) 
        state = STATE_1;
      else {
        remove_spc(charray, len, i);
        continue;
      }
      break;

    } // end switch

    i++;
    
    if(i == len)     
      break;
    
  } // end while

  len = strlen(charray);
  if(' ' == charray[len-1])
    charray[len-1] = 0;

  printf("\nClean string:%s\n", charray);
      
  return 0;
  
}
